"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var DateField =
/*#__PURE__*/
function (_ref) {
  _inherits(DateField, _ref);

  function DateField(props) {
    var _this;

    _classCallCheck(this, DateField);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DateField).call(this, props));
    _this.state = {};
    return _this;
  }

  _createClass(DateField, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          field = _this$props.field,
          layoutType = _this$props.layoutType,
          commonPrefixCls = _this$props.commonPrefixCls,
          labelWidth = _this$props.labelWidth,
          nullDisplayType = _this$props.nullDisplayType; // eslint-disable-next-line prefer-const

      var fieldName = field.fieldName,
          _field$fieldValue = field.fieldValue,
          fieldValue = _field$fieldValue === void 0 ? '{}' : _field$fieldValue,
          _field$fieldExtra = field.fieldExtra,
          fieldExtra = _field$fieldExtra === void 0 ? '{}' : _field$fieldExtra;
      fieldValue = JSON.parse(fieldValue);
      fieldExtra = JSON.parse(fieldExtra);
      var _fieldValue = fieldValue,
          text = _fieldValue.text,
          _fieldValue$texts = _fieldValue.texts,
          texts = _fieldValue$texts === void 0 ? [] : _fieldValue$texts;
      var _fieldExtra = fieldExtra,
          mode = _fieldExtra.mode;
      var showText;
      var nullValue;

      if (mode === 'RANGE') {
        if (!texts.length) {
          showText = '无';
          nullValue = true;
        } else if (layoutType === 0) {
          showText = _react["default"].createElement("div", null, _react["default"].createElement("div", null, texts[0]), _react["default"].createElement("div", null, "~ ", texts[1]));
        } else {
          showText = "".concat(texts[0], " ~ ").concat(texts[1]);
        }
      } else {
        showText = text || '无';
        nullValue = !text;
      }

      var prefixCls = 'eh-field-view-date';
      prefixCls += layoutType === 0 ? '-hor' : '-ver';
      var hidden = nullDisplayType === 1 && nullValue;
      return hidden ? null : _react["default"].createElement("div", {
        className: prefixCls
      }, _react["default"].createElement("div", {
        className: "".concat(commonPrefixCls, "-name"),
        style: {
          width: labelWidth
        }
      }, fieldName), _react["default"].createElement("div", {
        className: "".concat(commonPrefixCls, "-value")
      }, showText));
    }
  }]);

  return DateField;
}(_react.PureComponent || _react.Component);

DateField.PropTypes = {
  field: _propTypes["default"].object,
  // 字段数据
  layoutType: _propTypes["default"].number,
  // 字段的布局类型：0 - 左右结构（默认），1 - 上下结构
  nullDisplayType: _propTypes["default"].number,
  // 字段值为空时，显示的类型：0 - 显示'无'（默认），1 - 字段不显示
  commonPrefixCls: _propTypes["default"].string,
  // 所有字段通用的 prefixCls
  labelWidth: _propTypes["default"].number // label的宽度

};
DateField.defaultProps = {
  field: {}
};
var _default = DateField;
exports["default"] = _default;
module.exports = exports.default;