"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("antd-mobile/lib/modal/style");

var _modal = _interopRequireDefault(require("antd-mobile/lib/modal"));

require("antd-mobile/lib/icon/style");

var _icon = _interopRequireDefault(require("antd-mobile/lib/icon"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _moment = _interopRequireDefault(require("moment"));

var _getIconByFileName = _interopRequireDefault(require("./getIconByFileName"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FileField =
/*#__PURE__*/
function (_ref) {
  _inherits(FileField, _ref);

  function FileField(props) {
    var _this;

    _classCallCheck(this, FileField);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FileField).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "getFileSizeText", function (fileSize) {
      var text = '';

      if (fileSize >= 1024 * 1024) {
        text = "".concat((fileSize / 1024 / 1024).toFixed(2), "MB");
      } else if (fileSize >= 1024) {
        text = "".concat((fileSize / 1024).toFixed(2), "KB");
      } else {
        text = "".concat(fileSize, "B");
      }

      return text;
    });

    _defineProperty(_assertThisInitialized(_this), "clickField", function () {
      var scrollTop = document.body.scrollTop || document.documentElement.scrollTop;
      var rootElement = document.getElementById('root'); // 使 root 脱离文档流

      rootElement.classList.add('dialog-open'); // 把脱离文档流的 root 拉上去，否则页面会回到顶部！

      rootElement.style.top = "".concat(-scrollTop, "px");

      _this.setState({
        visible: true,
        bodyScrollTop: scrollTop
      });
    });

    _defineProperty(_assertThisInitialized(_this), "closeModal", function (e) {
      e.stopPropagation();
      var bodyScrollTop = _this.state.bodyScrollTop;
      var rootElement = document.getElementById('root');
      rootElement.classList.remove('dialog-open'); // 滚回到老地方

      document.body.scrollTop = bodyScrollTop;
      document.documentElement.scrollTop = bodyScrollTop;

      _this.setState({
        visible: false
      });
    });

    _this.state = {
      visible: false,
      bodyScrollTop: 0
    };
    return _this;
  }

  _createClass(FileField, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      // root回到文档流中
      var rootElement = document.getElementById('root');
      rootElement.classList.remove('dialog-open');
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          field = _this$props.field,
          layoutType = _this$props.layoutType,
          commonPrefixCls = _this$props.commonPrefixCls,
          labelWidth = _this$props.labelWidth,
          nullDisplayType = _this$props.nullDisplayType;
      var visible = this.state.visible; // eslint-disable-next-line prefer-const

      var fieldName = field.fieldName,
          _field$fieldValue = field.fieldValue,
          fieldValue = _field$fieldValue === void 0 ? '{}' : _field$fieldValue;
      fieldValue = JSON.parse(fieldValue);
      var _fieldValue = fieldValue,
          _fieldValue$files = _fieldValue.files,
          files = _fieldValue$files === void 0 ? [] : _fieldValue$files;
      var prefixCls = 'eh-field-view-file';
      var modalPrefixCls = "".concat(prefixCls, "-modal");
      prefixCls += layoutType === 0 ? '-hor' : '-ver';
      var hidden = nullDisplayType === 1 && !files.length;
      return hidden ? null : _react["default"].createElement("div", {
        className: prefixCls,
        onClick: !files.length || layoutType !== 0 ? null : this.clickField
      }, _react["default"].createElement("div", {
        className: "".concat(commonPrefixCls, "-name"),
        style: {
          width: labelWidth
        }
      }, fieldName), _react["default"].createElement("div", {
        className: "".concat(commonPrefixCls, "-value")
      }, files.length ? layoutType === 0 ? _react["default"].createElement("div", {
        className: "".concat(prefixCls, "-info")
      }, _react["default"].createElement("div", {
        className: "".concat(prefixCls, "-info-text")
      }, files.length, "\u4E2A\u9644\u4EF6"), _react["default"].createElement("i", {
        className: "".concat(prefixCls, "-info-icon iconfont icon-form_cell_arrow_icon")
      })) : _react["default"].createElement("div", {
        className: "".concat(prefixCls, "-list")
      }, files.map(function (file, index) {
        return _react["default"].createElement("div", {
          key: index,
          className: "".concat(prefixCls, "-file")
        }, _react["default"].createElement("div", {
          className: "".concat(prefixCls, "-file-icon")
        }, _react["default"].createElement("img", {
          src: (0, _getIconByFileName["default"])(file.fileName),
          alt: ""
        })), _react["default"].createElement("div", {
          className: "".concat(prefixCls, "-file-content")
        }, _react["default"].createElement("div", {
          className: "".concat(prefixCls, "-file-name")
        }, file.fileName), _react["default"].createElement("div", {
          className: "".concat(prefixCls, "-file-detail")
        }, _react["default"].createElement("div", {
          className: "".concat(prefixCls, "-file-time")
        }, (0, _moment["default"])(file.uploadTime).format('YYYY-MM-DD HH:mm')), _react["default"].createElement("div", {
          className: "".concat(prefixCls, "-file-size")
        }, _this2.getFileSizeText(file.fileSize)))));
      })) : '无'), _react["default"].createElement(_modal["default"], {
        popup: true,
        visible: visible,
        onClose: this.closeModal,
        animationType: "slide-up"
      }, _react["default"].createElement("div", {
        className: modalPrefixCls
      }, _react["default"].createElement("div", {
        className: "".concat(modalPrefixCls, "-header")
      }, _react["default"].createElement(_icon["default"], {
        type: "cross",
        onClick: this.closeModal
      }), _react["default"].createElement("span", {
        className: "".concat(modalPrefixCls, "-header-text")
      }, "".concat(fieldName, "(").concat(files.length, ")"))), _react["default"].createElement("div", {
        className: "".concat(modalPrefixCls, "-content")
      }, files.map(function (file, index) {
        return _react["default"].createElement("div", {
          key: index,
          className: "".concat(modalPrefixCls, "-item")
        }, _react["default"].createElement("div", {
          className: "".concat(modalPrefixCls, "-item-icon")
        }, _react["default"].createElement("img", {
          src: (0, _getIconByFileName["default"])(file.fileName),
          alt: ""
        })), _react["default"].createElement("div", {
          className: "".concat(modalPrefixCls, "-item-content")
        }, _react["default"].createElement("div", {
          className: "".concat(modalPrefixCls, "-item-name")
        }, file.fileName), _react["default"].createElement("div", {
          className: "".concat(modalPrefixCls, "-item-detail")
        }, _react["default"].createElement("div", {
          className: "".concat(modalPrefixCls, "-item-time")
        }, (0, _moment["default"])(file.uploadTime).format('YYYY-MM-DD HH:mm')), _react["default"].createElement("div", {
          className: "".concat(modalPrefixCls, "-item-size")
        }, _this2.getFileSizeText(file.fileSize)))));
      })))));
    }
  }]);

  return FileField;
}(_react.PureComponent || _react.Component);

FileField.PropTypes = {
  field: _propTypes["default"].object,
  // 字段数据
  layoutType: _propTypes["default"].number,
  // 字段的布局类型：0 - 左右结构（默认），1 - 上下结构
  nullDisplayType: _propTypes["default"].number,
  // 字段值为空时，显示的类型：0 - 显示'无'（默认），1 - 字段不显示
  commonPrefixCls: _propTypes["default"].string,
  // 所有字段通用的 prefixCls
  labelWidth: _propTypes["default"].number // label的宽度

};
FileField.defaultProps = {
  field: {}
};
var _default = FileField;
exports["default"] = _default;
module.exports = exports.default;