"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _fields = _interopRequireDefault(require("./fields"));

var _customFields = _interopRequireDefault(require("./customFields"));

var _fieldTypes = require("./variables/fieldTypes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var FieldView =
/*#__PURE__*/
function (_ref) {
  _inherits(FieldView, _ref);

  function FieldView(props) {
    var _this;

    _classCallCheck(this, FieldView);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FieldView).call(this, props));
    _this.state = {};
    return _this;
  }

  _createClass(FieldView, [{
    key: "render",
    value: function render() {
      // eslint-disable-next-line prefer-const
      var _this$props = this.props,
          formFields = _this$props.formFields,
          layoutType = _this$props.layoutType,
          nullDisplayType = _this$props.nullDisplayType;
      layoutType = Number(layoutType);
      nullDisplayType = Number(nullDisplayType);
      var prefixCls = 'eh-field-view';
      var commonPrefixCls = layoutType === 0 ? "".concat(prefixCls, "-hor") : "".concat(prefixCls, "-ver");
      var fieldNameLens = formFields.map(function (item) {
        return item.fieldName ? item.fieldName.length : 0;
      });
      var maxNameLength = Math.max.apply(Math, _toConsumableArray(fieldNameLens)); // 统一字段label的宽度

      var labelWidth = "".concat(maxNameLength * 34 / 100, "rem");
      return _react["default"].createElement("div", {
        className: "".concat(prefixCls, " ").concat(commonPrefixCls)
      }, formFields.map(function (field, index) {
        var fieldType = field.fieldType,
            fieldCustomType = field.fieldCustomType;
        var FieldComponent;

        if (fieldType !== _fieldTypes.CUSTOM) {
          FieldComponent = _fields["default"][fieldType];
        } else {
          FieldComponent = _customFields["default"][fieldCustomType];
        }

        if (FieldComponent) {
          return _react["default"].createElement(FieldComponent, {
            key: index,
            field: field,
            layoutType: layoutType,
            nullDisplayType: nullDisplayType,
            labelWidth: labelWidth,
            commonPrefixCls: commonPrefixCls
          });
        }

        return null;
      }));
    }
  }]);

  return FieldView;
}(_react.PureComponent || _react.Component);

FieldView.PropTypes = {
  formFields: _propTypes["default"].array,
  // 表单值数据
  layoutType: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  // 字段的布局类型：0 - 左右结构（默认），1 - 上下结构
  nullDisplayType: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]) // 字段值为空时，显示的类型：0 - 显示'无'（默认），1 - 字段不显示

};
FieldView.defaultProps = {
  formFields: [],
  layoutType: 0,
  nullDisplayType: 0
};
var _default = FieldView;
exports["default"] = _default;
module.exports = exports.default;